package info.bukova.isspst.ui.requirement;

import info.bukova.isspst.data.Requirement;
import info.bukova.isspst.data.Workgroup;
import info.bukova.isspst.filters.RequirementFilter;
import info.bukova.isspst.services.requirement.RequirementService;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.services.workgroups.WorkgroupService;
import info.bukova.isspst.ui.BigDecimalConverter;
import info.bukova.isspst.ui.ListViewModel;

import java.util.List;

import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;

public class RequirementList extends ListViewModel<Requirement> {

	@WireVariable
	private RequirementService requirementService;

	@WireVariable
	private UserService userService;

	@WireVariable
	private WorkgroupService workgroupService;

	private BigDecimalConverter bigDecimalConverter;

	public List<Workgroup> getCentres()
	{
		return workgroupService.getUserCentres(userService.getCurrent());
	}

	public BigDecimalConverter getBigDecimalConverter()
	{
		return bigDecimalConverter;
	}

	public void setBigDecimalConverter(BigDecimalConverter bigDecimalConverter)
	{
		this.bigDecimalConverter = bigDecimalConverter;
	}

	@Init
	public void init()
	{

		service = requirementService;
		dataClass = Requirement.class;
		formZul = "requirementsForm.zul";
		dataFilter = new RequirementFilter(getFilterTemplate());

		this.bigDecimalConverter = new BigDecimalConverter();
	}
}
