package info.bukova.isspst.ui.requirement;

import info.bukova.isspst.data.RequirementBase;
import info.bukova.isspst.services.requirement.RequirementBaseService;
import info.bukova.isspst.ui.ListViewModel;

import org.zkoss.bind.BindUtils;
import org.zkoss.bind.annotation.Command;
import org.zkoss.bind.annotation.NotifyChange;

public class RequirementSubpage<T extends RequirementBase> extends ListViewModel<T> {
	
	@SuppressWarnings("unchecked")
	private RequirementBaseService<T> getReqService()
	{
		return (RequirementBaseService<T>) service;
	}

	@Override
	protected void loadLazyData(T data) {
		this.getReqService().loadAuthItems(data);
		this.getReqService().loadWorkflow(data);
		this.getReqService().loadType(data);
	}
	
	@Command
	@NotifyChange({"dataBean", "canApprove"})
	public void approve() {
		this.getReqService().approve(getDataBean());
		BindUtils.postGlobalCommand(null, null, "reload", null);
	}

	@Override
	@NotifyChange({ "dataBean", "ableToDelete", "canApprove" })
	public void setDataBean(T data) {
		super.setDataBean(data);
	}
	
	public boolean isCanApprove() {
		if (getDataBean() != null) {
			return this.getReqService().canApprove(getDataBean());
		}
		
		return false;
	}
}
